/*
This external module was hand written @ home by Pierre with love in 2023

A big thanks to Jean-Emmanuel for his work !
Thanks also to @LowweK75 for his code, a lot of his work is used in this external module !!!
With the great help of Chat GPT and pieces of codes gathered at Open stage Control Community forum.
And of course, thanks to all the OSC community forum members.

You can use it freely and mod it to your taste, but please don't sell it or make money with it !
Please support jean-emmanuel work on Patreon :
https://www.patreon.com/openstagecontrol?fan_landing=true

The purpose of this external module is to be able to control Articulations from your select track
in Logic Pro via Articulation MIDI remote with Open Stage control. It can also add a fancy picture
of the selected track's soundbank

I won't guarantee it will work for you and I won't do hotline support (I'm busy writing music)
I won't be responsible for your computer smoking or for any data loss
It won't be my fault if you use this code to write either good or bad music

Please, read instructions from my original post on the Open Stage Control community forum :
https://openstagecontrol.discourse.group/t/articulations-full-dynamic-module-for-logic-with-detailed-instructions/3119/4

Enjoy !

                        Pierre



This is Version 0.Alpha

*/


//variables for the Logic Pro automatic articulations management
var artList = ""
var symbolList=""
var midiswitch=""
var artJSON='{"libraries":[' //to match trackname with articulations and library pictures
var locals = {}; // initialize locals variable for MackieControl datas
locals.text = locals.text || Array(112).fill(" "); // persistent variable to store MackieControl LCD text
var trackName = "" //MackieControl decoded Logic selected track name


/*

Extra components not installed with OpenStageControl :

PRE REQUIREMENT : Xcode must be installed from the App store
Then you must instal HomeBrew and Node

Open a Terminal
Go to the local OpenStageControl_modules directory (usually found under Documents)
Run the command: npm install xml2js
Then the command: npm install glob
Then the command: npm install plist

Have a look at my original post on the Open Stage Control community forum for detailled instructions 

*/

const fs = nativeRequire('fs');
const xml2js = nativeRequire('xml2js');
const glob = nativeRequire('glob'); //to access finder's articulations from Logic and your Libraries Pictures
const plist= nativeRequire('plist'); //to parse plist articulation files



//Directory where the articulation sets files are located :
//Please add an "OSC" folder in your "Articulation Settings" folder and correct the path with your personal User folder name
//THE FOLOWING LINE MUST BE CORRECTED WITH YOUR PERSONAL CONFIGURATION !
var mapFiles = glob.sync('/Users/yourusernamehere/Music/Audio Music Apps/Articulation Settings/OpenStageArticulations/*.plist')
//console.log(mapFiles) //all articulations individual files list from mac

//Directory where the library pictures are located (Folder must be at the same location than your .json OSC file) will take only jpeg & png files
//your picture folder has to be named : "Libpictures"
//THE FOLOWING LINE MUST BE CORRECTED WITH YOUR PERSONAL CONFIGURATION !
const files = glob.sync('/Users/yourusernamehere/Documents/OpenStageControl/Articulations_forLogic_byPierre/Libpictures/*.{png,jpeg}');

// Getting the library pictures name list from your Mac:
const pictNames = files.map(filePath => {
  const parts = filePath.split('/');
  return parts[parts.length - 1];
});

//Making a table with your library picture Keys
const picadValues = pictNames.map(name => name.match(/(?<=\[)[^\][]*(?=])/g)[0]);
const allPicts = picadValues.map((value, index) => ({
  Image: value,
  address: pictNames[index]
}));
// Convert to JSON string
const allPictsJSON = JSON.stringify({ libraries: allPicts });

// Parse JSON back to JavaScript object to be able to get the picture from the selected track name
const allPicts2 = JSON.parse(allPictsJSON);
//console.log(allPicts2);


//getting all articulations files from your mac :
for (const mapFile of mapFiles) {

        const data = plist.parse(fs.readFileSync(mapFile,'utf8'));
        //console.log(data) 

        artList="{"; 
        symbolList='"';
        for (let i = 0, len = data.Articulations.length; i < len; i++) {
  const articulation = data.Articulations[i];
  const switchData = data.Switches.find((switchItem) => switchItem.ID === articulation.ID);

  artList += '"' + articulation.Name + '":' + switchData.MB1 + ',';
  //console.log(artList); //view all datas


// This section is dedicated to colour-coded grid buttons
// You can modify it as you wish... or just ignore this if you don't want coloured buttons in the grid
            switch (data.Articulations[i].Symbol) {


                // Below all the "case ... break;" lines are matching a symbol among the symbol list found in Logic Pro articulation sets

                // The following set is not used in my articulation lists
                // I keep them here for future usage
                // Again, below is just for inspiration, I've put families in CAPS and the articulations often found in libraries, then a color
  
                    case "Fermata Down":symbolList+="#94d2bd,";break; //
                    case "Stroke Up":symbolList+="#94d2bd,";break; //
                    case "Stroke Down":symbolList+="#94d2bd,";break; //
                    case "Doit Short":symbolList+="#94d2bd,";break; //
                    case "Doit Long":symbolList+="#A3BE8C,";break; //
                    case "Scoop Short":symbolList+="#94d2bd,";break; //
                    case "Scoop Long":symbolList+="#94d2bd,";break; //
                    case "Martellato":symbolList+="#94d2bd,";break; //
                    case "Heavy":symbolList+="#94d2bd,";break; //

                // VERY SHORTS : imperial red f94144ff
                    case "Staccatissimo":symbolList+="#f94144,";break; //

                // SHORTS : orange crayola f3722c 
                    case "Staccato":symbolList+="#f3722c,";break; //

                // MID : carrot orange bb3e03
                    case "Marcato":symbolList+="#bb3e03,";break; //
                    case "Marcatissimo":symbolList+="#bb3e03,";break; //


                 // LONGS ACCENTED : pistacchio 90be6d
                    case "Double Accent":symbolList+="#90be6d,";break; //


                // LONGS : dark cyan 4d908e
                    case "Soft":symbolList+="#4d908e,";break; //
                    case "Flageolet":symbolList+="#B48EAD,";break; //


                // LEGATO : cerulean 277da1
                    case "Tenuto":symbolList+="#277da1,";break; //


                // LONGS SPECIAL : zomp 43aa8b
                    case "Fermata Up":symbolList+="#43aa8b,";break; //


                // DYNAMICS : tiffany blue 94d2bd
                    case "Fall Short":symbolList+="#94d2bd,";break; //
                    case "Fall Long":symbolList+="#94d2bd,";break; //

                // PLUCKED : coral f9844a
                    case "Pizzicato (Left Hand)":symbolList+="#EBCB8B,";break;    //              
                    
                // FX : paynes grey 577590
                    case "Left Hand":symbolList+="#577590,";break; //

                // OTHER : saffron f9c74f
                    case "Right Hand":symbolList+="#f9c74f,";break; //

                // Default is used for longs
                    //default:symbolList+="#4d908e,";
                        default:symbolList+="#5E81AC,";
            }
        }       
        artList=artList.replace(/.$/,"}");
        artList=artList==''?'"No articulations:0"':artList;
        symbolList=symbolList.replace(/.$/,'"');
        //console.log(artList); 
        
        var libraryName=mapFile.split('\\').pop().split('/').pop().split('.').shift();
        //console.log(libraryName);

        // libraryName contains the filename of the articulation set, for example : VSL Elite Strings [SES].plist
        // the line below extracts the value between brackets (in the example : SES) and use it as a library key :
        artJSON+='{"library":"'+libraryName.match(/(?<=\[)[^\][]*(?=])/g)+'","articulations":['+artList+'],"symbols":'+symbolList+'},';
        //console.log(libraryName);
        //console.log(artList);
        //console.log(symbolList);
}

artJSON=artJSON.replace(/.$/,"]}");
//a little bit of JSON magic
const allArts=JSON.parse(artJSON);
//console.log(artJSON);
//console.log(allArts);


//This function returns the articulations from the trackname
//In detail, the articulation sets are looped. If the trackname contains one of the keys (for example : Violins 1 - 6 SES) then the articulation set is return
function fetchArticulations (SelectedArticulation) {
    for (const thisLib of allArts.libraries) {
        if (trackName.includes(thisLib.library)) {
            return thisLib.articulations[0];
        }
    }

    return "";
}

//It's exactly the same as above, but this time, the colours are returned
function fetchColors (SelectedArticulation) {
    for (const thisLib of allArts.libraries) {
        if (trackName.includes(thisLib.library)) {
          return  thisLib.symbols;
        }
    }

    return "";
}


//This fuction returns the Library picture from the trackname
function fetchPicture (SelectedArticulation) {
    for (const thisPict of allPicts2.libraries) {
        if (trackName.includes(thisPict.Image)) {
          return  thisPict.address;
        }
    }

    return "";
}


module.exports = {
  oscInFilter: function (data) {

    var { address, args, host, port } = data;

    // getting Selected track name from MackieControl LCD

    var value = args[0].value;
    if (data.address === '/sysex' && data.args[0].value.includes("f0 00 00 66 14 12")) {
      // sysex header for mackie lcd text
      var d = value.split(" ").slice(6).map((x) => parseInt(x, 16)); // hex to int
      var pos = d[0]; // first byte -> position
      var text = d.slice(1).map((x) => String.fromCharCode(x)); // rest -> updated characters
      text.pop(); // drop sysex closing byte

      // update characters
      for (var i = 0; i < text.length; i++) {
        locals.text[i + pos] = text[i]; // update
      }

      // Extracting the Corect Trackname : update text widget croping start space and "
      trackName = locals.text.slice(9, 43).join("").replace('"', "").trimLeft().replace('"', "").trimRight();
     
      //Sending values from this external module to Open Stages via OSC datas :
      //selected track name, selected articulation names & notes and selected Library picture
      receive('/logicname',trackName)
      receive('/ArtList',fetchArticulations(data.args[0].value))
      //console.log(fetchArticulations(data.args[0].value))
      receive('/ArtColors',fetchColors(data.args[0].value))
      //receive('/Keyswitch',fetchMidi(data.args[0].value))
      receive('/Picture',fetchPicture(data.args[0].value))
      return
    }


    var { address, args, host, port } = data
    return {address, args, host, port}
  },

  oscOutFilter: function (data) {
    // Filter outgoing osc messages
    var { address, args, host, port, clientId } = data;
    // same as oscInFilter
    // return data if you want the message to be sent
    return data;
  },

  
};

